// Help functions for string processing

#include <string> // Include standard string class
#include <vector>  // Include STL vector class
#include <algorithm> // Include STL generic algorithms
#include <cctype>   // Include C character functions (tolower, ispunct)
using namespace std;

inline string normalize(const string& s) 
   // Translate characters to lower case 
   // and eliminate punctuation characters
{
   vector<char> v(s.data(), s.data() + s.length());

   transform(v.begin(), v.end(), v.begin(), tolower);
   vector<char>::iterator end1 = remove_if(v.begin(), v.end(), ispunct);
   v.erase(end1, v.end());
   return string(v.begin(), v.end());
}
